/*
 * JBoss, Home of Professional Open Source
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.test.security.ejb.jbas1852;

import java.security.Principal;
import java.rmi.RemoteException;
import javax.ejb.CreateException;
import javax.ejb.SessionContext;
import javax.ejb.SessionBean;
import javax.naming.InitialContext;
import javax.naming.NamingException;

/**
 * @author Scott.Stark@jboss.org
 * @version $Revision: 1.1 $
 */
public class PublicSessionFacade implements SessionBean
{
   private SessionContext sessionContext;

   public void ejbCreate() throws CreateException
   {
       System.out.println("PublicSessionBean.ejbCreate() called");
   }

   public void ejbActivate()
   {
       System.out.println("PublicSessionBean.ejbActivate() called");
   }

   public void ejbPassivate()
   {
       System.out.println("PublicSessionBean.ejbPassivate() called");
   }

   public void ejbRemove()
   {
       System.out.println("PublicSessionBean.ejbRemove() called");
   }

   public void setSessionContext(SessionContext context)
   {
       sessionContext = context;
   }

   public String callEcho(String arg)
      throws RemoteException
   {
      Principal user = sessionContext.getCallerPrincipal();
      String echoMsg = null;
      try
      {
         InitialContext ctx = new InitialContext();
         String jndiName = "java:comp/env/ejb/TargetEJB";
         SessionHome home = (SessionHome) ctx.lookup(jndiName);
         Session bean = home.create();
         echoMsg = bean.echo("Hello, arg="+arg);
         echoMsg = bean.echo("Hello 2, arg="+arg);
      }
      catch (NamingException e)
      {
         throw new RemoteException("callEcho failed", e);
      }
      catch (CreateException e)
      {
         throw new RemoteException("callEcho failed", e);
      }
      return echoMsg;
   }
}
